﻿using ClienteWindows.ServicioDepartamentosLocal;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ClienteWindows
{
    public partial class Form1 : Form
    {

        private ServicioDepartamentosSoapClient servicio = new ServicioDepartamentosSoapClient();


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            LlenarDataGrid();
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void dataGridView1_SelectionChanged(object sender, EventArgs e)
        {

            if (dataGridView1.SelectedRows.Count > 0)
            {
                var deptoId = (long) dataGridView1.SelectedRows[0].Cells[0].Value;
                var deptoNombre = (string) dataGridView1.SelectedRows[0].Cells[1].Value;

                txtId.Text = deptoId.ToString();
                txtNombre.Text = deptoNombre;

            }

        }

        private async void button2_Click(object sender, EventArgs e)
        {
            var deptoId = int.Parse(txtId.Text);
            var deptoNombre = txtNombre.Text;

            var servicio = new ServicioDepartamentosLocal.ServicioDepartamentosSoapClient();

            await servicio.EditarAsync(deptoId, deptoNombre);

            LlenarDataGrid();

        }

        private async void LlenarDataGrid()
        {
            this.Text = "Cargando datos...";
            var dataset = await servicio.ObtenerTodosAsync();
            dataGridView1.DataSource = dataset.Body.ObtenerTodosResult;
            this.Text = "Datos cargados";
        }

        private void button4_Click(object sender, EventArgs e)
        {

            var paginas = new List<string>()
            {
                "http://localhost:63134/Departamentos.aspx",
                "http://localhost:63134/Municipios.aspx",
                "http://localhost:63134/PersonasEditar.aspx"
            };

            paginas.Add("http://localhost:63134/Personas.aspx");


            var tiempoInicial = DateTime.Now;

            var i = 0;

            Parallel.ForEach(paginas.AsParallel(), (pagina) =>
            {
                i++;
                var client = new WebClient();
                client.DownloadString(pagina);
                pbTareas.Invoke(new Action(() => { pbTareas.Value = i * 25; }));
            });

            //foreach (var pagina in paginas)
            //{
            //    var client = new WebClient();
            //    client.DownloadString(pagina);
            //    pbTareas.Value = i * 25;
            //    i++;
            //}


            //for (int i = 0; i < paginas.Count; i++)
            //{
            //    var pagina = paginas[i];
            //    var client = new WebClient();
            //    client.DownloadString(pagina);
            //    pbTareas.Value = i * 25;
                
            //}

            var tiempoFinal = DateTime.Now;

            TimeSpan diferencia = (tiempoFinal - tiempoInicial);

            lblTareas.Text = (diferencia).TotalSeconds.ToString();

        }

        private void TareaX()
        {
            System.Threading.Thread.Sleep(100);
        }

    }
}
