﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Services;
using EmptyWebApp.Modelos;

namespace EmptyWebApp.Servicios
{
    /// <summary>
    /// Summary description for ServicioDepartamentos
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/", Description = "Servicio para gestionar <strong>departamentos</strong>")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class ServicioDepartamentos : System.Web.Services.WebService
    {

        private DepartamentoBL deptos = new DepartamentoBL();

        [WebMethod(Description = "Obtiene todos los departamentos del sistema")]
        public List<Departamento> ObtenerTodos()
        {

            return deptos.ObtenerTodos();
        }

        [WebMethod]
        public void Crear(string nombre)
        {
            deptos.Crear(nombre);
        }

        [WebMethod]
        public void Editar(int id, string nombre)
        {

            System.Threading.Thread.Sleep(2000);

            deptos.Editar(id, nombre);
        }

        [WebMethod]
        public void Eliminar(int id)
        {
            deptos.Eliminar(id);
        }

        [WebMethod]
        public Departamento ObtenerUnico(int id)
        {
            return deptos.ObtenerUnico(id);
        }
    }
}
